]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blob - samples/bpf/test_cgrp2_sock2.sh
Merge tag 'clk-for-linus' of git://git.kernel.org/pub/scm/linux/kernel/git/clk/linux
[mirror_ubuntu-jammy-kernel.git] / samples / bpf / test_cgrp2_sock2.sh
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3
4 function config_device {
5 ip netns add at_ns0
6 ip link add veth0 type veth peer name veth0b
7 ip link set veth0b up
8 ip link set veth0 netns at_ns0
9 ip netns exec at_ns0 ip addr add 172.16.1.100/24 dev veth0
10 ip netns exec at_ns0 ip addr add 2401:db00::1/64 dev veth0 nodad
11 ip netns exec at_ns0 ip link set dev veth0 up
12 ip addr add 172.16.1.101/24 dev veth0b
13 ip addr add 2401:db00::2/64 dev veth0b nodad
14 }
15
16 function config_cgroup {
17 rm -rf /tmp/cgroupv2
18 mkdir -p /tmp/cgroupv2
19 mount -t cgroup2 none /tmp/cgroupv2
20 mkdir -p /tmp/cgroupv2/foo
21 echo $$ >> /tmp/cgroupv2/foo/cgroup.procs
22 }
23
24
25 function attach_bpf {
26 test_cgrp2_sock2 /tmp/cgroupv2/foo sock_flags_kern.o $1
27 [ $? -ne 0 ] && exit 1
28 }
29
30 function cleanup {
31 if [ -d /tmp/cgroupv2/foo ]; then
32 test_cgrp2_sock -d /tmp/cgroupv2/foo
33 fi
34 ip link del veth0b
35 ip netns delete at_ns0
36 umount /tmp/cgroupv2
37 rm -rf /tmp/cgroupv2
38 }
39
40 cleanup 2>/dev/null
41
42 set -e
43 config_device
44 config_cgroup
45 set +e
46
47 #
48 # Test 1 - fail ping6
49 #
50 attach_bpf 0
51 ping -c1 -w1 172.16.1.100
52 if [ $? -ne 0 ]; then
53 echo "ping failed when it should succeed"
54 cleanup
55 exit 1
56 fi
57
58 ping6 -c1 -w1 2401:db00::1
59 if [ $? -eq 0 ]; then
60 echo "ping6 succeeded when it should not"
61 cleanup
62 exit 1
63 fi
64
65 #
66 # Test 2 - fail ping
67 #
68 attach_bpf 1
69 ping6 -c1 -w1 2401:db00::1
70 if [ $? -ne 0 ]; then
71 echo "ping6 failed when it should succeed"
72 cleanup
73 exit 1
74 fi
75
76 ping -c1 -w1 172.16.1.100
77 if [ $? -eq 0 ]; then
78 echo "ping succeeded when it should not"
79 cleanup
80 exit 1
81 fi
82
83 cleanup
84 echo
85 echo "*** PASS ***"